Subject: [IPFIX] Search comments and feedbacks about the draft of IPFIX IE extension when considering BGP community

From: "Ariel Gu" <[email-masked]>
Date: Tue, 19 Jul 2016 21:36:22 +0800

Hi, dear all.

Nice meeting you in the mail-list of IPFIX. This IETF in Berlin right now,
we submit a draft and present it about the IPFIX IE extension when
considering BGP community. I'm looking for comments and feedbacks about our
idea in new IE added in exporting the flow information correlated with BGP
community. As dear chair told me that the mail-list is still alive, I follow
the suggestion of putting my draft here and searching for advice and
suggestions in the right place. 

Before that, I made a short summary of my draft which may be helpful in
quick looking at the draft. When we consider traffic steering in our
backbone network, we feel that the flow information based on BGP community
is quite suitable. That's the reason why we write the draft. And we now
recommend two IEs which may be assigned by IANA: bgpSourceCommunityList and
bgpDestinationCommunityList. 

If you are facing up with this situations as us, then we can discuss about
the IEs especially the details. 

The information of my draft:
<https://www.ietf.org/internet-drafts/draft-li-opsawg-ipfix-bgp-community-00
.txt>
https://www.ietf.org/internet-drafts/draft-li-opsawg-ipfix-bgp-community-00.
txt

I'm looking forward for your comments.

Best regards and have a nice trip in Berlin.

-----------------------------------------------------------

Rong Gu
China Mobile Research Institute
No.32 Xuanwumen West Street, Xicheng District
Beijing, China, 100053
Mobile: +86 13811520541
Phone: +86 10 15801696688 Ext. 36211
Email:  <mailto:[email-masked]> [email-masked]

---

From: Benoit Claise <[email-masked]>
Date: Wed, 20 Jul 2016 09:12:03 +0200

Dear all,

We know that the IANA considerations 
<https://tools.ietf.org/html/rfc7012#section-7> mentions "expert review" 
for the IPFIX registry <https://www.iana.org/assignments/ipfix/ipfix.xhtml>.
This BGP community is actually a special IPFIX Information Element as 
this is the first one based on RFC 6313 
<https://tools.ietf.org/html/rfc6313>(basicList, subTemplateList, 
subTemplateMultiList)
So it deserves special attention, review, and potential documentation as 
its own RFC.

Regards, Benoit

> Hi, dear all.
>
> Nice meeting you in the mail-list of IPFIX. This IETF in Berlin right 
> now, we submit a draft and present it about the IPFIX IE extension 
> when considering BGP community. I’m looking for comments and feedbacks 
> about our idea in new IE added in exporting the flow information 
> correlated with BGP community. As dear chair told me that the 
> mail-list is still alive, I follow the suggestion of putting my draft 
> here and searching for advice and suggestions in the right place.
>
> Before that, I made a short summary of my draft which may be helpful 
> in quick looking at the draft. When we consider traffic steering in 
> our backbone network, we feel that the flow information based on BGP 
> community is quite suitable. That’s the reason why we write the draft. 
> And we now recommend two IEs which may be assigned by IANA: 
> bgpSourceCommunityList and bgpDestinationCommunityList.
>
> If you are facing up with this situations as us, then we can discuss 
> about the IEs especially the details.
>
> https://www.ietf.org/internet-drafts/draft-li-opsawg-ipfix-bgp-community-00.txt
>
> I’m looking forward for your comments.
>
> Email: [email-masked] <mailto:[email-masked]>
>

---

From: PJ Aitken <[email-masked]>
Date: Wed, 20 Jul 2016 15:49:06 +0100

When a draft specifies one of the list types, should it also specify the 
type of the list elements and the expected semantics?

Else we could have non-interoperable implementations exporting the same 
"IANA standard" information element, where one is a "basicList of X" 
while another is a "basicList of Y".
ie, although the IE is the same, the basicList Field ID and semantics 
are different. See RFC 6313, Figure 1.)

eg, the BGP community draft referenced below creates a new 
bgpSourceCommunityList. I suppose this may be a list of 
bgpSourceAsNumber, but that's not specified in the draft - so it could 
equally be a list of sourceIPv4Address or any other IE.

Alternatively, devices could simply export IE #291 (basicList), with the 
bgpSourceCommunityList and bgpDestinationCommunityList disambiguated by 
the basicList Field ID contained in the basicList header. However that 
would be horrendous for collectors...

P.

On 20/07/16 08:12, Benoit Claise wrote:
> <https://urldefense.proofpoint.com/v2/url?u=https-3A__tools.ietf.org_html_rfc7012-23section-2D7&d=CwMDEA&c=IL_XqQWOjubgfqINi2jTzg&r=Xx9729xYDYoCgBDdcp1FKt5PyYd1TCoXNKhyPY8CFp8&m=ZslthyAR_pCMk0ceVDm68IQNaZBed3zfEKAlZ4zaux4&s=PT25lVmWADTBAoRFJls07fJ6PTOd2XWc0L4bTWxB3MY&e=> 
> mentions "expert review" for the IPFIX registry 
> <https://urldefense.proofpoint.com/v2/url?u=https-3A__www.iana.org_assignments_ipfix_ipfix.xhtml&d=CwMDEA&c=IL_XqQWOjubgfqINi2jTzg&r=Xx9729xYDYoCgBDdcp1FKt5PyYd1TCoXNKhyPY8CFp8&m=ZslthyAR_pCMk0ceVDm68IQNaZBed3zfEKAlZ4zaux4&s=tbt3wdaVgevcKVTqBEKX_MhNO7g_oaW3XiywAp65WgY&e=>.
> <https://urldefense.proofpoint.com/v2/url?u=https-3A__tools.ietf.org_html_rfc6313&d=CwMDEA&c=IL_XqQWOjubgfqINi2jTzg&r=Xx9729xYDYoCgBDdcp1FKt5PyYd1TCoXNKhyPY8CFp8&m=ZslthyAR_pCMk0ceVDm68IQNaZBed3zfEKAlZ4zaux4&s=R9ipRubr7eEQrMnskDLzBjeZqhpnmefnWc59t3_ab7s&e=>(basicList, 
> subTemplateList, subTemplateMultiList)
> So it deserves special attention, review, and potential documentation 
> as its own RFC.
>
> Regards, Benoit
>
>> Hi, dear all.
>>
>> when considering BGP community. I’m looking for comments and 
>> feedbacks about our idea in new IE added in exporting the flow 
>> information correlated with BGP community. As dear chair told me that 
>> the mail-list is still alive, I follow the suggestion of putting my 
>> draft here and searching for advice and suggestions in the right place.
>>
>> community is quite suitable. That’s the reason why we write the 
>> draft. And we now recommend two IEs which may be assigned by IANA: 
>> <https://urldefense.proofpoint.com/v2/url?u=https-3A__www.ietf.org_internet-2Ddrafts_draft-2Dli-2Dopsawg-2Dipfix-2Dbgp-2Dcommunity-2D00.txt&d=CwMDEA&c=IL_XqQWOjubgfqINi2jTzg&r=Xx9729xYDYoCgBDdcp1FKt5PyYd1TCoXNKhyPY8CFp8&m=ZslthyAR_pCMk0ceVDm68IQNaZBed3zfEKAlZ4zaux4&s=T9dMbA_3xk8ZMfCI0dkNONKt1xL04aoMa8vn_-9FBns&e=>
>>
> _______________________________________________
> IPFIX mailing list
> [email-masked]
> https://urldefense.proofpoint.com/v2/url?u=https-3A__www.ietf.org_mailman_listinfo_ipfix&d=CwICAg&c=IL_XqQWOjubgfqINi2jTzg&r=Xx9729xYDYoCgBDdcp1FKt5PyYd1TCoXNKhyPY8CFp8&m=ZslthyAR_pCMk0ceVDm68IQNaZBed3zfEKAlZ4zaux4&s=mL0br6tuMk78xRPYaHEPxZ5usdrXvvMI1C_g105zdws&e=

---

From: Benoit Claise <[email-masked]>
Date: Sun, 24 Jul 2016 00:22:36 +0200

On 7/20/2016 4:49 PM, PJ Aitken wrote:
> When a draft specifies one of the list types, should it also specify 
> the type of the list elements and the expected semantics?
Yes. And I suppose that it would come from a BGP community reference in 
a BGP RFC in this case.

Regards, B.
>
> Else we could have non-interoperable implementations exporting the 
> same "IANA standard" information element, where one is a "basicList of 
> X" while another is a "basicList of Y".
> Alternatively, devices could simply export IE #291 (basicList), with 
> the bgpSourceCommunityList and bgpDestinationCommunityList 
> disambiguated by the basicList Field ID contained in the basicList 
> header. However that would be horrendous for collectors...
>
> P.
>
>
>>> Nice meeting you in the mail-list of IPFIX. This IETF in Berlin 
>>> right now, we submit a draft and present it about the IPFIX IE 
>>> extension when considering BGP community. I’m looking for comments 
>>> and feedbacks about our idea in new IE added in exporting the flow 
>>> information correlated with BGP community. As dear chair told me 
>>> that the mail-list is still alive, I follow the suggestion of 
>>> putting my draft here and searching for advice and suggestions in 
>>> the right place.
>>>

---

From: "[email-masked]" <[email-masked]>
Date: Fri, 29 Jul 2016 16:10:33 +0800

Hello P. Aitken and all,

If the suggested IE numbers are assigned by IANA, 458 not 291 SHOULD be encoded in the Field ID field in the basicList for bgpSourceCommunityList, and 459 SHOULD be encoded for bgpDestinationCommunityList.

basicList is an IE type defined in RFC6313. We can use this type to define new IEs if type basicList is applicable.

Sorry for delayed response.

Best Regards,

[email-masked]
 
From: PJ Aitken
Date: 2016-07-20 22:49
To: Benoit Claise; Ariel Gu; [email-masked]; [email-masked]; [email-masked]
CC: lizhenqiang; Brian Trammell; [email-masked]
Subject: Re: [IPFIX] Search comments and feedbacks about the draft of IPFIX IE extension when considering BGP community
When a draft specifies one of the list types, should it also specify the type of the list elements and the expected semantics?

Else we could have non-interoperable implementations exporting the same "IANA standard" information element, where one is a "basicList of X" while another is a "basicList of Y".
ie, although the IE is the same, the basicList Field ID and semantics are different. See RFC 6313, Figure 1.)

eg, the BGP community draft referenced below creates a new bgpSourceCommunityList. I suppose this may be a list of bgpSourceAsNumber, but that's not specified in the draft - so it could equally be a list of sourceIPv4Address or any other IE.

Alternatively, devices could simply export IE #291 (basicList), with the bgpSourceCommunityList and bgpDestinationCommunityList disambiguated by the basicList Field ID contained in the basicList header. However that would be horrendous for collectors...

P.

We know that the IANA considerations mentions "expert review" for the IPFIX registry.
This BGP community is actually a special IPFIX Information Element as this is the first one based on RFC 6313  (basicList, subTemplateList, subTemplateMultiList) 
So it deserves special attention, review, and potential documentation as its own RFC.

Regards, Benoit
 
Hi, dear all.
Nice meeting you in the mail-list of IPFIX. This IETF in Berlin right now, we submit a draft and present it about the IPFIX IE extension when considering BGP community. I’m looking for comments and feedbacks about our idea in new IE added in exporting the flow information correlated with BGP community. As dear chair told me that the mail-list is still alive, I follow the suggestion of putting my draft here and searching for advice and suggestions in the right place. 
 
Before that, I made a short summary of my draft which may be helpful in quick looking at the draft. When we consider traffic steering in our backbone network, we feel that the flow information based on BGP community is quite suitable. That’s the reason why we write the draft. And we now recommend two IEs which may be assigned by IANA: bgpSourceCommunityList and bgpDestinationCommunityList. 
 
If you are facing up with this situations as us, then we can discuss about the IEs especially the details. 
 
The information of my draft: https://www.ietf.org/internet-drafts/draft-li-opsawg-ipfix-bgp-community-00.txt
 
Email: [email-masked]

---

From: Paul Aitken <[email-masked]>
Date: Fri, 29 Jul 2016 09:30:21 +0100

Li, two Information Element IDs are required for each basicList:

The first Information Element is the basicList itself. This element ID 
goes in the IPFIX template "Information Element id" field as usual, per 
figures G and L of RFC 7011. Effectively this is the outer "container" 
element.

IDs 458 and 459 define basicList Information Elements, so these are the 
first (outer, container) elements.

The second Information Element describes the type of each list element. 
This goes in the basicList Field ID per Figure 1 of RFC 6313. 
Effectively this is the inner "contained" element.

It's these second (inner, contained) elements which are missing.

Practically, we could have:

     bgpSourceCommunityList (458) = list of bgpSourceAsNumber (16)

or

     bgpSourceCommunityList (458) = list of sourceIPv4Address (8)

or in fact any other Information Element could be used as the "list of 
..." element.

In order to ensure this Information Element is interoperable, the 
missing element ID should be clearly stated in the draft.

P.

On 29/07/2016 09:10, [email-masked] wrote:
> Hello P. Aitken and all,
>
> If the suggested IE numbers are assigned by IANA, 458 not 291 SHOULD 
> be encoded in the Field ID field in the basicList for 
> bgpSourceCommunityList, and 459 SHOULD be encoded for 
> basicList is an IE type defined in RFC6313. We can use this type to 
> define new IEs if type basicList is applicable.
>
> ------------------------------------------------------------------------
>     *From:* PJ Aitken <mailto:[email-masked]>
>     *Date:* 2016-07-20 22:49
>     *To:* Benoit Claise <mailto:[email-masked]>; Ariel Gu
>     <mailto:[email-masked]>; [email-masked]
>     <mailto:[email-masked]>; [email-masked]
>     <mailto:[email-masked]>; [email-masked]
>     <mailto:[email-masked]>
>     *CC:* lizhenqiang <mailto:[email-masked]>; Brian
>     Trammell <mailto:[email-masked]>; [email-masked]
>     <mailto:[email-masked]>
>     *Subject:* Re: [IPFIX] Search comments and feedbacks about the
>     draft of IPFIX IE extension when considering BGP community
>     When a draft specifies one of the list types, should it also
>     specify the type of the list elements and the expected semantics?
>
>     same "IANA standard" information element, where one is a
>     "basicList of X" while another is a "basicList of Y".
>     ie, although the IE is the same, the basicList Field ID and
>     semantics are different. See RFC 6313, Figure 1.)
>
>     bgpSourceAsNumber, but that's not specified in the draft - so it
>     could equally be a list of sourceIPv4Address or any other IE.
>
>     Alternatively, devices could simply export IE #291 (basicList),
>     with the bgpSourceCommunityList and bgpDestinationCommunityList
>>     This BGP community is actually a special IPFIX Information
>>     Element as this is the first one based on RFC 6313
>>>     extension when considering BGP community. I’m looking for
>>>     comments and feedbacks about our idea in new IE added in
>>>     exporting the flow information correlated with BGP community. As
>>>     dear chair told me that the mail-list is still alive, I follow
>>>     the suggestion of putting my draft here and searching for advice
>>>     and suggestions in the right place.
>>>
>>>     Before that, I made a short summary of my draft which may be
>>>     helpful in quick looking at the draft. When we consider traffic
>>>     steering in our backbone network, we feel that the flow
>>>     information based on BGP community is quite suitable. That’s the
>>>     reason why we write the draft. And we now recommend two IEs
>>>     which may be assigned by IANA: bgpSourceCommunityList and
>>>     If you are facing up with this situations as us, then we can
>>>     discuss about the IEs especially the details.
>>>
> ie-doctors mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/ie-doctors

---

From: "[email-masked]" <[email-masked]>
Date: Fri, 29 Jul 2016 17:32:32 +0800

Hello Benoit Claise and all,

Yes, you are right. But what we want to introduce are two new IEs, not new IE types. We use the IE type basicList defined in RFC6313 to specify our IEs. The expected semantics is list, which represents an arbitrary-length sequence of zero or more structured data Information Elements. 

basicList content is determied by the IE number. 458 is suggested for bgpSourceCommunityList, BGP community information corresponding with source IP address of the specific flow SHOULD be encoded in the basicList content field of this IE. 459 is suggested for bgpDestinationCommunityList, BGP community information corresponding with destination IP address of the specific flow SHOULD be encoded in the basicList content field of this IE.

Best Regards, 

From: Benoit Claise
Date: 2016-07-24 06:22
To: PJ Aitken; Ariel Gu; ipfix; n.brownlee; quittek
CC: lizhenqiang; Brian Trammell; [email-masked]
Subject: Re: [IPFIX] Search comments and feedbacks about the draft of IPFIX IE extension when considering BGP community
On 7/20/2016 4:49 PM, PJ Aitken wrote:
When a draft specifies one of the list types, should it also specify the type of the list elements and the expected semantics?
Yes. And I suppose that it would come from a BGP community reference in a BGP RFC in this case.

Regards, B.

P.

Regards, Benoit
 
Hi, dear all.

---

From: "[email-masked]" <[email-masked]>
Date: Fri, 29 Jul 2016 17:56:31 +0800

Hi P. Aitken,

Yes, you are right. We need two IE IDs for each basicList. But 291 is already there, it is for the IPFIX template IE ID, not 458 or 459.
458 or 459 is for the type of each list element. It goes in the Field ID of the basicList.

bgpSourceCommunityList (458) = basic list(291) of bgp community infromation (defined in RFC1997)  corresponding with source IP address
bgpDestinationCommunityList (459) = basic list(291) of bgp community infromation (defined in RFC1997)  corresponding with destination IP address

Here, basic list meas zero or more bgp communities will be contained in the data set.

Best Regards,

From: Paul Aitken
Date: 2016-07-29 16:30
To: [email-masked]; PJ Aitken; Benoit Claise; gurong; [email-masked]; [email-masked]; [email-masked]; Dongjie (Jimmy)
CC: [email-masked]; Brian Trammell
Subject: Re: [Ie-doctors] [IPFIX] Search comments and feedbacks about the draft of IPFIX IE extension when considering BGP community
Li, two Information Element IDs are required for each basicList:

The first Information Element is the basicList itself. This element ID goes in the IPFIX template "Information Element id" field as usual, per figures G and L of RFC 7011. Effectively this is the outer "container" element.

IDs 458 and 459 define basicList Information Elements, so these are the first (outer, container) elements.

The second Information Element describes the type of each list element. This goes in the basicList Field ID per Figure 1 of RFC 6313. Effectively this is the inner "contained" element.

or

or in fact any other Information Element could be used as the "list of ..." element.

In order to ensure this Information Element is interoperable, the missing element ID should be clearly stated in the draft.

P.

Best Regards,

From: PJ Aitken
Date: 2016-07-20 22:49

P.

Regards, Benoit
 
Hi, dear all.

---

From: PJ Aitken <[email-masked]>
Date: Fri, 29 Jul 2016 11:23:22 +0100

Li, could you draw an example IPFIX template and data record showing the 
encoding of the bgpSourceCommunityList and bgpDestinationCommunityList ?

This would be a useful appendix in the draft.

P.

On 29/07/16 10:56, [email-masked] wrote:
> Hi P. Aitken,
>
> Yes, you are right. We need two IE IDs for each basicList. But 291 is 
> already there, it is for the IPFIX template IE ID, not 458 or 459.
> bgpSourceCommunityList (458) = basic list(291) of bgp community 
> infromation (defined in RFC1997)  corresponding with source IP address
> bgpDestinationCommunityList (459) = basic list(291) of bgp community 
> infromation (defined in RFC1997) 
>  corresponding with destination IP address
>
>     *From:* Paul Aitken <mailto:[email-masked]>
>     *Date:* 2016-07-29 16:30
>     *To:* [email-masked]
>     <mailto:[email-masked]>; PJ Aitken
>     <mailto:[email-masked]>; Benoit Claise
>     <mailto:[email-masked]>; gurong
>     <mailto:[email-masked]>; Dongjie (Jimmy)
>     <mailto:[email-masked]>
>     *CC:* [email-masked] <mailto:[email-masked]>; Brian
>     Trammell <mailto:[email-masked]>
>     *Subject:* Re: [Ie-doctors] [IPFIX] Search comments and feedbacks
>     about the draft of IPFIX IE extension when considering BGP community
>     The first Information Element is the basicList itself. This
>     element ID goes in the IPFIX template "Information Element id"
>     field as usual, per figures G and L of RFC 7011. Effectively this
>     is the outer "container" element.
>
>     IDs 458 and 459 define basicList Information Elements, so these
>     are the first (outer, container) elements.
>
>
>     The second Information Element describes the type of each list
>     element. This goes in the basicList Field ID per Figure 1 of RFC
>     6313. Effectively this is the inner "contained" element.
>
>>     If the suggested IE numbers are assigned by IANA, 458 not 291
>>     SHOULD be encoded in the Field ID field in the basicList for
>>     basicList is an IE type defined in RFC6313. We can use this type
>>     to define new IEs if type basicList is applicable.
>>
>>         Trammell <mailto:[email-masked]>;
>>         [email-masked] <mailto:[email-masked]>
>>         *Subject:* Re: [IPFIX] Search comments and feedbacks about
>>         the draft of IPFIX IE extension when considering BGP community
>>         Else we could have non-interoperable implementations
>>         exporting the same "IANA standard" information element, where
>>         one is a "basicList of X" while another is a "basicList of Y".
>>         bgpSourceAsNumber, but that's not specified in the draft - so
>>         it could equally be a list of sourceIPv4Address or any other IE.
>>
>>         Alternatively, devices could simply export IE #291
>>         (basicList), with the bgpSourceCommunityList and
>>         bgpDestinationCommunityList disambiguated by the basicList
>>         Field ID contained in the basicList header. However that
>>>>         Nice meeting you in the mail-list of IPFIX. This IETF in
>>>>         Berlin right now, we submit a draft and present it about
>>>>         the IPFIX IE extension when considering BGP community. I’m
>>>>         looking for comments and feedbacks about our idea in new IE
>>>>         added in exporting the flow information correlated with BGP
>>>>         community. As dear chair told me that the mail-list is
>>>>         still alive, I follow the suggestion of putting my draft
>>>>         Before that, I made a short summary of my draft which may
>>>>         be helpful in quick looking at the draft. When we consider
>>>>         traffic steering in our backbone network, we feel that the
>>>>         flow information based on BGP community is quite suitable.
>>>>         That’s the reason why we write the draft. And we now
>>>>         recommend two IEs which may be assigned by IANA:
>>>>         If you are facing up with this situations as us, then we
>>>>         can discuss about the IEs especially the details.
>>>>

---

From: "[email-masked]" <[email-masked]>
Date: Fri, 29 Jul 2016 18:26:45 +0800

Sure, my pleasure to do that in the next version. Thank you very much.

Best Regards,

From: PJ Aitken
Date: 2016-07-29 18:23
To: [email-masked]; Benoit Claise; gurong; [email-masked]; [email-masked]; [email-masked]; Dongjie (Jimmy)
CC: [email-masked]; Brian Trammell
Subject: Re: [Ie-doctors] [IPFIX] Search comments and feedbacks about the draft of IPFIX IE extension when considering BGP community
Li, could you draw an example IPFIX template and data record showing the encoding of the bgpSourceCommunityList and bgpDestinationCommunityList ?

P.

Best Regards,

From: Paul Aitken
Date: 2016-07-29 16:30

or

P.

Best Regards,

From: PJ Aitken
Date: 2016-07-20 22:49

P.

Regards, Benoit
 
Hi, dear all.